#Использовать "helpers"

&Тест
Процедура ТестДетектораLinux() Экспорт
	
	Детектор = Новый ДетекторПроцессораLinux();
	Если Не Детектор.Доступен() Тогда
		Возврат;
	КонецЕсли;

	ИнформацияОПроцессоре = Детектор.Определить();

	ПроверитьЗаполнение(ИнформацияОПроцессоре);

КонецПроцедуры

&Тест
Процедура ТестНедоступностиДетектораLinux() Экспорт
	
	Детектор = Новый ДетекторПроцессораLinux();
	Если Детектор.Доступен() Тогда
		Возврат;
	КонецЕсли;

	Ожидаем.Что(Детектор).Метод("Определить").ВыбрасываетИсключение("Детектор доступен только на Linux");

КонецПроцедуры

&Тест
Процедура ТестДетектораWindows() Экспорт
	
	Детектор = Новый ДетекторПроцессораWindows();
	Если Не Детектор.Доступен() Тогда
		Возврат;
	КонецЕсли;

	ИнформацияОПроцессоре = Детектор.Определить();

	ПроверитьЗаполнение(ИнформацияОПроцессоре);

КонецПроцедуры

&Тест
Процедура ТестНедоступностиДетектораWindows() Экспорт
	
	Детектор = Новый ДетекторПроцессораWindows();
	Если Детектор.Доступен() Тогда
		Возврат;
	КонецЕсли;

	Ожидаем.Что(Детектор).Метод("Определить").ВыбрасываетИсключение("Детектор доступен только на Windows");

КонецПроцедуры

&Тест
Процедура ТестДетектораMacOS() Экспорт
	
	Детектор = Новый ДетекторПроцессораMacOS();
	Если Не Детектор.Доступен() Тогда
		Возврат;
	КонецЕсли;

	ИнформацияОПроцессоре = Детектор.Определить();

	ПроверитьЗаполнение(ИнформацияОПроцессоре);

КонецПроцедуры

&Тест
Процедура ТестНедоступностиДетектораMacOS() Экспорт
	
	Детектор = Новый ДетекторПроцессораMacOS();
	Если Детектор.Доступен() Тогда
		Возврат;
	КонецЕсли;

	Ожидаем.Что(Детектор).Метод("Определить").ВыбрасываетИсключение("Детектор доступен только на MacOS");

КонецПроцедуры

&Тест
Процедура ТестДетектора() Экспорт

	ИнформацияОПроцессоре = ДетекторПроцессора.Определить();

	ПроверитьЗаполнение(ИнформацияОПроцессоре);

КонецПроцедуры

Процедура ПроверитьЗаполнение(ИнформацияОПроцессоре)

	Сообщить(ИнформацияОПроцессоре.ПолноеОписание());
	Сообщить(ИнформацияОПроцессоре.Архитектура);

	Ожидаем.Что(ИнформацияОПроцессоре.ИмяПроцессора, "Имя процессора").Заполнено();
	Ожидаем.Что(ИнформацияОПроцессоре.КоличествоПроцессоров, "Количество процессоров").Заполнено();
	Ожидаем.Что(ИнформацияОПроцессоре.КоличествоЯдер, "Количество ядер").Заполнено();
	Ожидаем.Что(ИнформацияОПроцессоре.КоличествоЛогическихПроцессоров, "Количество логических процессоров").Заполнено();
	Ожидаем.Что(ИнформацияОПроцессоре.Архитектура, "Архитектура").Заполнено();

КонецПроцедуры